#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SeniorPrizeWeight.h"
std::auto_ptr<Fish_SeniorPrizeWeight> Fish_SeniorPrizeWeight::msSingleton(nullptr);

int Fish_SeniorPrizeWeight::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorPrizeWeightData* Fish_SeniorPrizeWeight::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SeniorPrizeWeightData>& Fish_SeniorPrizeWeight::GetMapData()
{
	return mMapData;
}

void Fish_SeniorPrizeWeight::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SeniorPrizeWeight.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorPrizeWeightData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mgraphID = element->IntAttribute("graphID");
		data.mWeight = element->IntAttribute("Weight");
		data.mDivideJackpotRate = element->IntAttribute("DivideJackpotRate");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mJackpotValue = element->IntAttribute("JackpotValue");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SeniorPrizeWeight Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorPrizeWeight::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SeniorPrizeWeight");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SeniorPrizeWeight");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SeniorPrizeWeightData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "graphID", data.mgraphID);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "DivideJackpotRate", data.mDivideJackpotRate);
		LuaCfgHelper::readInt(L, "ItemID", data.mItemID);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "JackpotValue", data.mJackpotValue);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SeniorPrizeWeight Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorPrizeWeight::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SeniorPrizeWeight* Fish_SeniorPrizeWeight::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorPrizeWeight());
	}
	return msSingleton.get();
}

void Fish_SeniorPrizeWeight::Release()
{
	msSingleton.reset(nullptr);
}
